'use strict';
var{classes:Cc,interfaces:Ci,utils:Cu}=Components;
Cu.import('resource://gre/modules/Services.jsm');
Cu.import('resource://gre/modules/NetUtil.jsm');
var NoNeedFlash={
_windowtype:'navigator:browser',

get _windows(){
	let wins=[];
	this._windowtype||(this._windowtype='navigator:browser');
	let cw=Services.wm.getEnumerator(this._windowtype);
	while(cw.hasMoreElements()){
		let win=cw.getNext();
		win.QueryInterface(Ci.nsIDOMWindow);
		wins.push(win);
	}
	return wins;
},

handleEvent:function(e){
	let doc=e.target;
	let win=doc.defaultView;
	win.removeEventListener('load',this,true);
	if(doc.documentElement.getAttribute('windowtype')!==this._windowtype)return;
	this.loadScript(win);
},

loadScript:function(win){
	Services.scriptloader.loadSubScript(this._overlay,win,'UTF-8');
	'NoNeedFlash' in win && typeof win.NoNeedFlash.init==='function' && win.NoNeedFlash.init(win);
},

unloadScript:function(win){
	'NoNeedFlash' in win && typeof win.NoNeedFlash.uninit==='function' && win.NoNeedFlash.uninit(win);
},

onOpenWindow:function(aWindow){
	let win=aWindow.QueryInterface(Ci.nsIInterfaceRequestor).getInterface(Ci.nsIDOMWindowInternal||Ci.nsIDOMWindow);
	win.addEventListener('load',this,true);
	if(Components.classes['@mozilla.org/xre/app-info;1'].getService(Components.interfaces.nsIXULAppInfo).name=='Fennec')
		win.addEventListener('UIReady',function(event){
			win.removeEventListener('UIReady',arguments.callee,false);
			win.NoNeedFlash.init(win);
		},false);
},
onCloseWindow:function(aWindow){},
onWindowTitleChange:function(aWindow,aTitle){},

init:function(){
	this._wm=Services.wm;
	this._wm.addListener(this);
	this._windows.forEach(function(win){this.loadScript(win);},this);
	Services.obs.addObserver(this,'http-on-modify-request',false);
},

uninit:function(){
	if(this._wm)this._wm.removeListener(this);
	delete this._wm;
	this._windows.forEach(function(win){this.unloadScript(win);},this);
	Services.obs.removeObserver(this,'http-on-modify-request');
},

observe:function(aSubject,aTopic,aData){
	if(aTopic==='http-on-modify-request'){
		aSubject.QueryInterface(Ci.nsIHttpChannel);
		if(/[./]youtube\.com\/(embed|v)\//.test(aSubject.URI.spec))
			try{aSubject.URI.spec=aSubject.URI.spec.replace(/\/v\//,"/embed/")+'?html5=1';}catch(e){}
	}
}
};

function startup(data,reason){
	NoNeedFlash._overlay=data.resourceURI.spec+'overlay.js';
	NoNeedFlash.init();
}
function shutdown(data,reason){
	NoNeedFlash.uninit();
}
function install(data,reason){}
function uninstall(data,reason){}